<?php
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


//
// component: com_axiswebcam
// author:    Johannes Zweng <john@zweng.at>
// license:   GPL-2 (see LICENSE file for details)
// webpage:   http://www.johannes.zweng.at/
//


class axiswebcam_html {


	// printOfflineMessage()
	// prints a message that the camera is offline at the moment
	function printOfflineMessage() {
		echo '<br/>Sorry, but the camera is not online at the moment...<br/>';
		echo 'Please visit us later again.<br/><br/>';
	}


	// displayVideo():
	// Depending on browser or user choice it prints out the 
	// needed-html stuff to display the video
	function displayVideo($use_technology, $size) {
		debug_me("will display video with technology '$use_technology' and size '$size'");
		echo '<table border="0" cellspacing="0" cellpadding="0">';
		echo "<tr><td>\n";
		if ($use_technology == "mjpg") {
			axiswebcam_html::displayMJPGVideo($size);
		} else if ($use_technology == "java") {
			axiswebcam_html::displayJavaApplet($size);
		} else if ($use_technology == "flash") {
			axiswebcam_html::displayFlashVideo($size);
		} else if ($use_technology == "activex") {
			axiswebcam_html::displayActiveX($size);
		} else if ($use_technology == "still") {
			axiswebcam_html::displayStillImage($size);
		} else {
			axiswebcam_html::displayMJPGVideo($size);
		}
		echo '</td></tr>';
		echo "</table>\n";
}


	// displayActiveX()
	// Prints the object tag for the ActiveX Control to display
	// the video.
	// ARGS: size: one of 0.5, 1, 2, 4 - how much should the video be stretched
	function displayActiveX($size) {
		global $width, $height, $camera_ip, $camera_port, $compression;
		if ($size != 0.5 && $size != 1 && $size != 2 && $size != 4) {
			$size = 1;
		}
		$displayHeight = $height * $size;
		$displayWidth = $width * $size;

		echo '<OBJECT ID="Player" width="';
		echo $displayWidth;
		echo '" height="';
		// make it bigger for displaying the activeX control's buttons..
		$biggerHeight = $displayHeight + 35;
		echo $biggerHeight;
		echo '" CLASSID="CLSID:745395C8-D0E1-4227-8586-624CA9A10A8D" ';
		echo 'CODEBASE="http://';
		echo $camera_ip;
		echo ":";
		echo $camera_port;
		echo '/activex/AMC.cab#version=2,0,22,0">';
		print "\n";
		echo '<PARAM NAME="MediaURL" VALUE="http://';
		echo $camera_ip;
		echo ":";
		echo $camera_port;
		echo '/axis-cgi/mjpg/video.cgi?resolution=';
		echo $width;
		echo 'x';
		echo $height;
		echo '&compression=';
		echo $compression;
		echo '">';
		print "\n";
		echo <<<EOF
		<param name="MediaType" value="mjpeg-unicast">
		<param name="ShowStatusBar" value="0">
		<param name="ShowToolbar" value="1">
		<param name="AutoStart" value="1">
		<param name="StretchToFit" value="1">
		<param name="ToolbarConfiguration" value="fullscreen">
		<font face="Verdana, Geneva, Arial, Helvetica, sans-serif" size="2">
		<table border="0" width="620">
		<tr><td>
		<BR><BR><B>Axis Media ActiveX Control</B><BR><BR>
		The Axis Media ActiveX Control for playing live streams of AXIS webcams could not be found.<br><br>
		You can:<br>
		<ul><li>either install it, when you get asked for it (or by clicking on the yellow info bar at the top 
		of the Internet Explorer window)
		</li>
		<li>or you can choose another technology for displaying the video, by clicking one of the links below.
		</li></ul>
		</font>
		<BR><BR><BR><BR>
		</td></tr></table>
		</OBJECT>
		<SCRIPT LANGUAGE="JavaScript">
		<!--
			document.Player.ToolbarConfiguration = "play,fullscreen";
		//-->
		</SCRIPT>
EOF;
	}


	// displayJavaApplet()
	// Prints the applet tag to display the stream-playing 
	// Java Applet.
	// ARGS: size: one of 0.5, 1, 2, 4 - how much should the video be stretched
	function displayJavaApplet($size) {
		global $width, $height, $camera_ip, $camera_port, $compression;
		if ($size != 0.5 && $size != 1 && $size != 2 && $size != 4) {
			$size = 1;
		}
		$displayHeight = $height * $size;
		$displayWidth = $width * $size;

		echo '<APPLET ARCHIVE=AxisCamApplet.zip CODEBASE="http://';
		echo $camera_ip;
		echo ":";
		echo $camera_port;
		echo '/java/"';
		echo ' CODE=AxisCamApplet.class HEIGHT="';
		echo $displayHeight;
		echo '" WIDTH="';
		echo $displayWidth;
		echo '">';
		print "\n";
		echo '<PARAM NAME="StreamLocation" VALUE="http://';
		echo $camera_ip;
		echo ":";
		echo $camera_port;
		echo '/axis-cgi/mjpg/video.cgi?resolution=';
		echo $width;
		echo 'x';
		echo $height;
		echo '&compression=';
		echo $compression;
		echo '&showlength=1">';
		print "\n";
		echo <<<EOF
		</APPLET>
		<SCRIPT LANGUAGE="JavaScript">	
		<!--
		document.onstop=stopit;
		function stopit() {
			document.applets[0].stop();
		}
		//-->
		</SCRIPT>
EOF;
	}


// displayFlashVideo:
// Prints the embed tag to display the stream-playing flash movie.
// ARGS: size: one of 0.5, 1, 2, 4 - how much should the video be stretched
// RETURNS: nothing
function displayFlashVideo($size) {
	global $width, $height, $camera_ip, $camera_port, $compression;
	if ($size != 0.5 && $size != 1 && $size != 2 && $size != 4) {
		$size = 1;
	}
	$displayHeight = $height * $size;
	$displayWidth = $width * $size;
	?>
	<!-- 

	// =================================================================
	// =================================================================
	// =================================================================
	
	// FLASH VIDEO:
	// The following script adds a "base href" tag via javascript
	// DOM manipulation, which points to the Axis webcam 
	// because otherwise the flash video doesn't work
	// It seems that the webcam references the flash video relatively..
	
	
	// BIG BAD DRAWBACK OF THIS: all the links on the Joomla! page (menu, 
	// modules, etc.. DON'T WORK ANYMORE because they're all relatively 
	// and now point to the webcam...   :-(
	
	// Sorry, I have no solution for this.. (of course, you can use another technology..)

	// =================================================================
	// =================================================================
	// =================================================================	
	-->
	<?php
	echo "\n\n<script type = \"text/javascript\">\n";
	echo "<!--\n";
	echo "var base = document.createElement('base');\n";
	echo "base.setAttribute('href', 'http://";
	echo $camera_ip; echo ':'; echo $camera_port;
	echo "/');\n";
	echo "var head = document.getElementsByTagName('head').item(0);\n";
	echo "head.appendChild(base);\n";	
	echo "//-->\n";
	echo "</script>\n\n";
	
	echo '<OBJECT  classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" ';
	echo 'codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0" WIDTH="';
	echo $displayWidth;
	echo '" HEIGHT="';
	echo $displayHeight;
	echo '">';
	print "\n";
	echo '<PARAM name="movie" value="http://';
	echo $camera_ip;
	echo ":";
	echo $camera_port;
	echo '/axis-cgi/mjpg/video.swf?size=4&resolution=';
	echo $width;
	echo 'x';
	echo $height;
	echo '&camera=';
	echo '">';
	print "\n";
	echo '<PARAM NAME="quality" value="high">';
	print "\n";
	echo '<EMBED src="http://';
	echo $camera_ip;
	echo ":";
	echo $camera_port;
	echo '/axis-cgi/mjpg/video.swf?size=4&resolution=';
	echo $width;
	echo 'x';
	echo $height;
	echo '&camera=';
	echo '" ';
	echo 'quality="high" bgcolor="#000000" ';
	echo 'TYPE="application/x-shockwave-flash" swLiveConnect="TRUE" width="';
	echo $displayWidth;
	echo '" height="';
	echo $displayHeight;
	echo '" PLUGINSPAGE="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash">';
	echo '</EMBED>';
	print "\n";
	echo '<NOEMBED>';
	echo '<br><br><br><table border="0" width="620"><tr><td>';
	echo 'You need the Shockwave Flash plugin installed to watch the live stream as flash video.<br><br>';
	echo 'You can download it from the ';
	echo '<a href="http://www.macromedia.com/shockwave/download/">website of Macromedia</a>.';
	echo 'or you can choose another technology for displaying the live-stream by clicking one of the links below.</td></tr></table><br><br><br>';
	echo '</NOEMBED></OBJECT><br>';
}


// displayMJPGVideo:
// Prints the img-tag, which refers directly to the
// mjpg-stream.
// ARGS: size: one of 0.5, 1, 2, 4 - how much should the video be stretched
// RETURNS: nothing
function displayMJPGVideo($size) {
	global $width, $height, $camera_ip, $camera_port, $compression;
	if ($size != 0.5 && $size != 1 && $size != 2 && $size != 4) {
		$size = 1;
	}
	$displayHeight = $height * $size;
	$displayWidth = $width * $size;

	echo '<IMG SRC="http://';
	echo $camera_ip;
	echo ":";
	echo $camera_port;
	echo '/axis-cgi/mjpg/video.cgi?resolution=';
	echo $width;
	echo 'x';
	echo $height;
	echo '&compression=';
	echo $compression;
	echo '" HEIGHT="';
	echo $displayHeight;
	echo '" WIDTH="';
	echo $displayWidth;
	echo '" ALT="Live Webcam Video">';
}


// displayStillImage:
// Prints the img-tag, which refers to a still image.
// ARGS: size: one of 0.5, 1, 2, 4 - how much should the video be stretched
// RETURNS: nothing
function displayStillImage($size) {
	global $width, $height, $camera_ip, $camera_port, $compression;
	if ($size != 0.5 && $size != 1 && $size != 2 && $size != 4) {
		$size = 1;
	}
	$displayHeight = $height * $size;
	$displayWidth = $width * $size;

	echo '<IMG SRC="http://';
	echo $camera_ip;
	echo ":";
	echo $camera_port;
	echo '/jpg/image.jpg';
	echo '" HEIGHT="';
	echo $displayHeight;
	echo '" WIDTH="';
	echo $displayWidth;
	echo '" ALT="Live Webcam Picture">';
}

// printButtons:
// Prints the buttons above the video for choosing the size.
function printViewsizeButtons() {
	global $technology, $size, $Itemid, $website_url;
	echo '<table border="0" cellspacing="5" cellpadding="0"><tr>';
	echo '<td valign="middle">View size:</td><td valign="middle">';

	if ($size != 0.5) {
		echo '<a title="Display half sized video." href="';
		echo $website_url;
		echo '/index.php?option=com_axiswebcam&Itemid=';
		echo $Itemid;
		echo '&technology='; echo $technology; echo '&size=0.5">';
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x05_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Half size"></a>';
	} else {
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x05_gray_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Half size">';
	}
	echo '</td><td valign="middle">';

	if ($size != 1) {
		echo '<a title="Display normal sized video." href="';
		echo $website_url;
		echo 'index.php?option=com_axiswebcam&Itemid=';
		echo $Itemid;
		echo '&technology='; echo $technology; echo '&size=1">';
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x1_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Normal size"></a>';
	} else {
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x1_gray_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Normal size">';
	}
	echo '</td><td valign="middle">';

	if ($size != 2) {
		echo '<a title="Display double sized video." href="';
		echo $website_url;
		echo 'index.php?option=com_axiswebcam&Itemid=';
		echo $Itemid;
		echo '&technology='; echo $technology; echo '&size=2">';
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x2_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Double size"></a>';
	} else {
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x2_gray_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Double size">';
	}
	echo '</td><td valign="middle">';

	if ($size != 4) {
		echo '<a title="Display quadro sized video." href="';
		echo $website_url;
		echo 'index.php?option=com_axiswebcam&Itemid=';
		echo $Itemid;
		echo '&technology='; echo $technology; echo '&size=4">';
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x4_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Quadro size"></a>';
	} else {
		echo '<img src="';
		echo $website_url;
		echo 'components/com_axiswebcam/images/button_x4_gray_27x27px.gif" ';
		echo 'border="0" width="27" height="27" alt="Quadro size">';
	}

	echo '</td></tr></table>';
}

// printTechnologyLinks()
// prints out links to change technology
function printTechnologyLinks() {
	global $technology, $size, $website_url, $Itemid;
	echo '<table border="0" cellspacing="1" cellpadding="0"><tr><td>';
	 
	if ($technology != "activex") {
		echo '<a title="Play the video stream using an ActiveX Control" href="';
		echo $website_url;
		echo "index.php?option=com_axiswebcam&Itemid=$Itemid&technology=activex&size=$size\">[ ActiveX ]</a>";
	} else echo "[ ActiveX ]";
	echo "&nbsp;&nbsp;&nbsp;";
	if ($technology != "flash") {
		echo '<a title="Play the video stream using the Flash plugin." href="';
		echo $website_url;
		echo "index.php?option=com_axiswebcam&Itemid=$Itemid&technology=flash&size=$size\">[ Flash Video ]</a>";
	} else echo "[ Flash Video ]";
	echo "&nbsp;&nbsp;&nbsp;";
	if ($technology != "java") {
		echo '<a title="Play the video stream using a Java Applet." href="';
		echo $website_url;
		echo "index.php?option=com_axiswebcam&Itemid=$Itemid&technology=java&size=$size\">[ Java Applet ]</a>";
	} else echo "[ Java Applet ]";
	echo "&nbsp;&nbsp;&nbsp;";
	if ($technology != "mjpg") {
		echo '<a title="Play the MJPG stream directly in the browser." href="';
		echo $website_url;
		echo "index.php?option=com_axiswebcam&Itemid=$Itemid&technology=mjpg&size=$size\">[ MJPG Stream ]</a>";
	} else echo "[ MJPG Stream ]";
	echo "&nbsp;&nbsp;&nbsp;";
	if ($technology != "still") {
		echo '<a title="Just show the current snapshot of the webcam." href="';
		echo $website_url;
		echo "index.php?option=com_axiswebcam&Itemid=$Itemid&technology=still&size=$size\">[ Still image ]</a>";
	} else echo "[ Still image ]";
	
	echo "</td></tr><tr><td>";
	
	echo "Currently playing as:&nbsp;";
	if ($technology == "activex") {
		echo 'ActiveX Control <i>(works only with Internet Explorer)</i>';
	} else if ($technology == "java") {
		echo 'Java Applet <i>(<a href="http://jdl.sun.com/webapps/getjava/BrowserRedirect?host=www.java.com:80" target="_top">Java plugin</a> has to be installed)</i>';
	} else if ($technology == "still") {
		echo 'Still image (<i><a href="javascript:location.reload()">Reload</a></i>)';
	} else if ($technology == "flash") {
		echo 'Flash Video <i>(<a href="http://www.macromedia.com/shockwave/download/" ';
		echo 'target="_top">Macromedia Flash Plugin</a> has to be installed)</i>';
	} else {
		echo "MJPG-stream <i>(doesn't work with Internet Explorer)</i>";
	}
	echo "</td></tr></table>";
}


}

?>
