<?php
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


// include the configuration
// (As this is my first joomla component, I have no idea how to build an
// interface to set the configuration values in the backend. So I have all config
// values in a separate php-file).
require_once( 'components/com_axiswebcam/configuration.php' );

// and include the html class
require_once( 'components/com_axiswebcam/axiswebcam.html.php' );


// Get the technology parameter (java-applet, flash, activex, mjpg)
$technology = mosGetParam( $_GET, "technology" );
$size = mosGetParam( $_GET, "size" );
debug_me("parameter 'technology' from GET request: '$technology'");
debug_me("parameter 'size' from GET request: '$size'");


//
// WE ARE STARTING HERE!!
//
start();



//
//
// Below here are all the used functions:
//
//



// starts the component
function start() {
	global $size, $technology;
	chooseTechnology();
	chooseSize();
	if (isCameraOnline()) {
		axiswebcam_html::printViewsizeButtons();
		axiswebcam_html::displayVideo($technology, $size);
		axiswebcam_html::printTechnologyLinks();
	} else {
		axiswebcam_html::printOfflineMessage();
	}
}


// chooseBrowserDefaults()
// Here we define the default technologies for the different
// browsers.
function chooseBrowserDefault() {
	global $technology;
	$browser = getBrowser();
	// Here we define the defaults for the different browsers
	if ($browser == "msie") {
		$technology = "activex";
	} else if ($browser == "opera") {
		$technology = "java";
	} else if ($browser == "konqueror") {
		$technology = "flash";
	} else if ($browser == "safari") {
		$technology = "flash";
	} else {
		$technology = "mjpg";
	}
	debug_me("detected browser: $browser");
	debug_me("default for detected browser: $technology");
} 

// finallyChooseTechnology()
// Decides which technology should be used to display the video
// based on user inputs and browser defaults
function chooseTechnology() {
	global $technology;
	if (isset($technology) && strlen($technology)>0 ) {
		if ($technology != "mjpg" &&
		    $technology != "java" &&
		    $technology != "flash" &&
		    $technology != "still" &&
		    $technology != "activex")
		{
			debug_me("got invalid technology '$technology', will use browser default");
			chooseBrowserDefault();
		}
	} else {
		debug_me("got no technology parameter, will use browser default");
		chooseBrowserDefault();
	}
	debug_me("using technology: $technology");
}


// chooseSize()
// decides which size factor we shoukd use to display the video.
// Default value is 1
function chooseSize() {
	global $size;
	if (isset($size) && strlen($size)>0 ) {
		if ($size != 0.5 &&
		    $size != 1 &&
		    $size != 2 &&
		    $size != 4) 
		{
			debug_me("got invalid size parameter, will use default 1");
			$size = 1;
		}
	} else {
		debug_me("got no size parameter, will use default 1");
		$size = 1;
	}
	debug_me("will use size: $size");
}


// isCameraOnline()
// returns true, if tghe camera is online, false otherwise.
function isCameraOnline() {
	global $camera_ip, $camera_port;
	// try to connect to the camera with 1 seconds timeout.
	// if the camera doesn't respond after 1 seconds, this function
	// returns with an error.

	// disable displaying errors..
	ini_set("display_errors", "false");

	debug_me("checking if camera is online at http://$camera_ip:$camera_port");
	$socket = fsockopen( $camera_ip, $camera_port, $errno, $errstr, 1);
	if ($socket) {
		debug_me("success, camera is online!");
		fclose( $socket );
		return true;
	} else {
		debug_me("cannot connect to camera, will assume it's offline");
		return false;
	}
}
											

// getBrowser()
// very simple browser etection
function getBrowser() {
	if( eregi("opera",$_SERVER['HTTP_USER_AGENT'],$regs) ) {
		$browser = "opera";
	} else if( eregi("safari",$_SERVER['HTTP_USER_AGENT'],$regs) ) {
		$browser = "safari";
	} else if( eregi("netscape",$_SERVER['HTTP_USER_AGENT'],$regs) ) {
		$browser = "netscape";
	} else if( eregi("msie",$_SERVER['HTTP_USER_AGENT'],$regs) ) {
		$browser = "msie";
	} else if( eregi("firefox",$_SERVER['HTTP_USER_AGENT'],$regs) ) {
		$browser = "firefox";
	} else if( eregi("konqueror",$_SERVER['HTTP_USER_AGENT'],$regs) ) {
		$browser = "konqueror";
	} else if( eregi("lynx",$_SERVER['HTTP_USER_AGENT'],$regs) ) {
		$browser = "lynx";
	} else if( eregi("mozilla",$_SERVER['HTTP_USER_AGENT']) ) {
		$browser = "mozilla";
	} else if( eregi("w3m",$_SERVER['HTTP_USER_AGENT']) ) {
		$browser = "w3m";
	} else {
		$browser = "other";
	}  
	return $browser;
}

?>
